package com.diagbot.exception;

import com.diagbot.dto.RespDTO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;


/**
 * @Description: 错误通用处理
 * @author: gaodm
 * @time: 2018/8/2 14:22
 */
@ControllerAdvice
@ResponseBody
@Slf4j
public class CommonExceptionHandler {

    @ExceptionHandler(Exception.class)
    public ResponseEntity<RespDTO> handleException(Exception e) {
        RespDTO resp = new RespDTO();
        if(e instanceof CommonException) {
            CommonException taiChiException = (CommonException) e;
            resp.code = taiChiException.getCode();
            resp.msg = e.getMessage();
            log.error("【业务异常】:" + e.getMessage());
            return new ResponseEntity(resp, HttpStatus.OK);
        }
        resp.code = -1;
        resp.msg = e.getMessage();
        log.error("【系统异常】:" + e.getMessage());
        return new ResponseEntity(resp, HttpStatus.OK);
    }

}
